(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[11],{

/***/ "rlLj":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__("jm00");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _regenerator = _interopRequireDefault(__webpack_require__("hJxD"));
var _toConsumableArray2 = _interopRequireDefault(__webpack_require__("QGb3"));
var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__("HZZ/"));
var _classCallCheck2 = _interopRequireDefault(__webpack_require__("GeFe"));
var _createClass2 = _interopRequireDefault(__webpack_require__("Zvb3"));
var _defineProperty2 = _interopRequireDefault(__webpack_require__("J58c"));
var Sentry = _interopRequireWildcard(__webpack_require__("eS0f"));
var _cozyClient = __webpack_require__("xEu0");
var _cozyLogger = _interopRequireDefault(__webpack_require__("rUPj"));
var _doctypes = __webpack_require__("rVhO");
var _enums = __webpack_require__("j0hM");
var _luxon = __webpack_require__("1EDv");
var _logger = _interopRequireDefault(__webpack_require__("DPwE"));
var _utils = __webpack_require__("RgLR");
var _account = _interopRequireDefault(__webpack_require__("dB3v"));
var _fluidConfig = _interopRequireDefault(__webpack_require__("i5q2"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var logStack = _cozyLogger.default.namespace('enedisMonthlyAnalysisDataService');
var EnedisMonthlyAnalysisDataService = exports.default = /*#__PURE__*/function () {
  function EnedisMonthlyAnalysisDataService(_client) {
    (0, _classCallCheck2.default)(this, EnedisMonthlyAnalysisDataService);
    (0, _defineProperty2.default)(this, "_client", void 0);
    (0, _defineProperty2.default)(this, "aggregateValuesToDataLoad", function (data) {
      var dataLoadWeekDays = [];
      var dataLoadWeekEndDays = [];
      data.weekDaysHalfHourAverageValues.forEach(function (value, index) {
        dataLoadWeekDays.push({
          value: value,
          state: _enums.DataloadState.VALID,
          valueDetail: null,
          date: _luxon.DateTime.fromObject({
            year: data.year,
            month: data.month,
            minute: 0
          }).setZone('utc', {
            keepLocalTime: true
          }).plus({
            minute: 30 * index
          })
        });
      });
      data.weekEndDaysHalfHourAverageValues.forEach(function (value, index) {
        dataLoadWeekEndDays.push({
          value: value,
          state: _enums.DataloadState.VALID,
          valueDetail: null,
          date: _luxon.DateTime.fromObject({
            year: data.year,
            month: data.month,
            minute: 0
          }).setZone('utc', {
            keepLocalTime: true
          }).plus({
            minute: 30 * index
          })
        });
      });
      return {
        week: dataLoadWeekDays,
        weekend: dataLoadWeekEndDays
      };
    });
    this._client = _client;
  }

  /**
   * getLastEnedisMonthlyAnalysis
   */
  (0, _createClass2.default)(EnedisMonthlyAnalysisDataService, [{
    key: "getLastEnedisMonthlyAnalysis",
    value: function () {
      var _getLastEnedisMonthlyAnalysis = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        var query, data;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                query = (0, _cozyClient.Q)(_doctypes.ENEDIS_MONTHLY_ANALYSIS_DATA_DOCTYPE).where({}).indexFields(['year', 'month']).sortBy([{
                  year: 'desc'
                }, {
                  month: 'desc'
                }]).limitBy(1);
                _context.next = 3;
                return this._client.query(query);
              case 3:
                data = _context.sent;
                return _context.abrupt("return", data.data);
              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
      function getLastEnedisMonthlyAnalysis() {
        return _getLastEnedisMonthlyAnalysis.apply(this, arguments);
      }
      return getLastEnedisMonthlyAnalysis;
    }()
    /**
     * Aggregates Enedis Analysis data in order to create Dataload injectable in graph component
     */
  }, {
    key: "getEnedisMonthlyAnalysisByDate",
    value:
    /**
     * Get an enedis monthly analysis for given month and year
     */
    function () {
      var _getEnedisMonthlyAnalysisByDate = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(year, month) {
        var query, data;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                query = (0, _cozyClient.Q)(_doctypes.ENEDIS_MONTHLY_ANALYSIS_DATA_DOCTYPE).where({
                  year: year,
                  month: month
                }).indexFields(['year', 'month']).sortBy([{
                  year: 'desc'
                }, {
                  month: 'desc'
                }]).limitBy(1);
                _context2.next = 3;
                return this._client.query(query);
              case 3:
                data = _context2.sent;
                return _context2.abrupt("return", data.data);
              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
      function getEnedisMonthlyAnalysisByDate(_x, _x2) {
        return _getEnedisMonthlyAnalysisByDate.apply(this, arguments);
      }
      return getEnedisMonthlyAnalysisByDate;
    }()
    /**
     * Creates a new EnedisMonthlyAnalysis
     */
  }, {
    key: "createEnedisMonthlyAnalysisData",
    value: function () {
      var _createEnedisMonthlyAnalysisData = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(newEnedisMonthlyAnalysisData) {
        var _yield$this$_client$c, EnedisMonthlyAnalysis, errorMessage;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _context3.next = 3;
                return this._client.create(_doctypes.ENEDIS_MONTHLY_ANALYSIS_DATA_DOCTYPE, newEnedisMonthlyAnalysisData);
              case 3:
                _yield$this$_client$c = _context3.sent;
                EnedisMonthlyAnalysis = _yield$this$_client$c.data;
                return _context3.abrupt("return", EnedisMonthlyAnalysis);
              case 8:
                _context3.prev = 8;
                _context3.t0 = _context3["catch"](0);
                errorMessage = "Error creating new EnedisMonthlyAnalysis: ".concat(JSON.stringify(_context3.t0));
                logStack('error', errorMessage);
                _logger.default.error(errorMessage);
                Sentry.captureException(_context3.t0);
                throw _context3.t0;
              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 8]]);
      }));
      function createEnedisMonthlyAnalysisData(_x3) {
        return _createEnedisMonthlyAnalysisData.apply(this, arguments);
      }
      return createEnedisMonthlyAnalysisData;
    }()
    /**
     * Get Max power for a given month and year
     */
  }, {
    key: "getMaxPowerByDate",
    value: function () {
      var _getMaxPowerByDate = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4(year, month) {
        var query, data;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                query = (0, _cozyClient.Q)(_doctypes.ENEDIS_MAXPOWER_DOCTYPE).where({
                  year: year,
                  month: month
                }).indexFields(['year', 'month']).sortBy([{
                  year: 'desc'
                }, {
                  month: 'desc'
                }]);
                _context4.next = 3;
                return this._client.query(query);
              case 3:
                data = _context4.sent;
                return _context4.abrupt("return", data.data);
              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
      function getMaxPowerByDate(_x4, _x5) {
        return _getMaxPowerByDate.apply(this, arguments);
      }
      return getMaxPowerByDate;
    }()
  }, {
    key: "getOffPeakHours",
    value: function () {
      var _getOffPeakHours = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee5() {
        var _account$data;
        var accountService, fluidConfig, account;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                accountService = new _account.default(this._client);
                fluidConfig = new _fluidConfig.default().getFluidConfig();
                _context5.next = 4;
                return accountService.getAccountByType(fluidConfig[_enums.FluidType.ELECTRICITY].konnectorConfig.slug);
              case 4:
                account = _context5.sent;
                if (account !== null && account !== void 0 && (_account$data = account.data) !== null && _account$data !== void 0 && _account$data.offPeakHours) {
                  _context5.next = 7;
                  break;
                }
                return _context5.abrupt("return", null);
              case 7:
                return _context5.abrupt("return", (0, _utils.parseOffPeakHours)(account.data.offPeakHours));
              case 8:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
      function getOffPeakHours() {
        return _getOffPeakHours.apply(this, arguments);
      }
      return getOffPeakHours;
    }()
  }, {
    key: "getOffPeakHoursRatio",
    value: function () {
      var _getOffPeakHoursRatio = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee6(year, month, offPeakHours) {
        var roundedOffPeakHours, splittedOffPeakHours, formattedOffPeakHours, offPeakHoursConsumption, monthQuery, _yield$this$_client$q, monthDocs;
        return _regenerator.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                roundedOffPeakHours = (0, _utils.roundOffPeakHours)(offPeakHours);
                splittedOffPeakHours = (0, _utils.splitOffPeakHours)(roundedOffPeakHours);
                formattedOffPeakHours = splittedOffPeakHours.map(function (split) {
                  return (0, _utils.formatOffPeakHours)(split);
                }).join(';');
                logStack('debug', "Fetching half-hour consumption for the ranges : ".concat(formattedOffPeakHours));
                _context6.next = 6;
                return this.getOffPeakHourConsumption(splittedOffPeakHours, year, month);
              case 6:
                offPeakHoursConsumption = _context6.sent;
                monthQuery = (0, _cozyClient.Q)(_doctypes.ENEDIS_MONTH_DOCTYPE).where({
                  year: year,
                  month: month
                }).indexFields(['year', 'month']).limitBy(1);
                _context6.next = 10;
                return this._client.query(monthQuery);
              case 10:
                _yield$this$_client$q = _context6.sent;
                monthDocs = _yield$this$_client$q.data;
                return _context6.abrupt("return", offPeakHoursConsumption / monthDocs[0].load);
              case 13:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
      function getOffPeakHoursRatio(_x6, _x7, _x8) {
        return _getOffPeakHoursRatio.apply(this, arguments);
      }
      return getOffPeakHoursRatio;
    }()
  }, {
    key: "getOffPeakHourConsumption",
    value: function () {
      var _getOffPeakHourConsumption = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee7(offPeakHours, year, month) {
        var minuteDocs, _iterator, _step, range, start, end, minuteQuery, _yield$this$_client$q2, docs, firstHalfHourQuery, _yield$this$_client$q3, _docs, offPeakHoursConsumption;
        return _regenerator.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                minuteDocs = [];
                _iterator = _createForOfIteratorHelper(offPeakHours);
                _context7.prev = 2;
                _iterator.s();
              case 4:
                if ((_step = _iterator.n()).done) {
                  _context7.next = 22;
                  break;
                }
                range = _step.value;
                start = range.start, end = range.end;
                minuteQuery = (0, _cozyClient.Q)(_doctypes.ENEDIS_MINUTE_DOCTYPE).where({
                  year: year,
                  month: month,
                  $and: [{
                    $or: [{
                      hour: {
                        $gt: start.hour
                      }
                    }, {
                      $and: [{
                        hour: start.hour
                      }, {
                        minute: {
                          $gt: start.minute
                        }
                      }]
                    }]
                  }, {
                    $or: [{
                      hour: {
                        $lt: end.hour
                      }
                    }, {
                      $and: [{
                        hour: end.hour
                      }, {
                        minute: {
                          $lte: end.minute
                        }
                      }]
                    }]
                  }]
                }).limitBy(500);
                _context7.next = 10;
                return this._client.query(minuteQuery);
              case 10:
                _yield$this$_client$q2 = _context7.sent;
                docs = _yield$this$_client$q2.data;
                minuteDocs = [].concat((0, _toConsumableArray2.default)(minuteDocs), (0, _toConsumableArray2.default)(docs));

                // if the half-hour 23H30-0H00 is required, add the 0H00-0H30 consumption because the data is shifted in DB
                if (!(end.hour === 23 && end.minute === 59)) {
                  _context7.next = 20;
                  break;
                }
                firstHalfHourQuery = (0, _cozyClient.Q)(_doctypes.ENEDIS_MINUTE_DOCTYPE).where({
                  year: year,
                  month: month,
                  hour: 0,
                  minute: 0
                });
                _context7.next = 17;
                return this._client.query(firstHalfHourQuery);
              case 17:
                _yield$this$_client$q3 = _context7.sent;
                _docs = _yield$this$_client$q3.data;
                minuteDocs = [].concat((0, _toConsumableArray2.default)(minuteDocs), (0, _toConsumableArray2.default)(_docs));
              case 20:
                _context7.next = 4;
                break;
              case 22:
                _context7.next = 27;
                break;
              case 24:
                _context7.prev = 24;
                _context7.t0 = _context7["catch"](2);
                _iterator.e(_context7.t0);
              case 27:
                _context7.prev = 27;
                _iterator.f();
                return _context7.finish(27);
              case 30:
                logStack('debug', "Found ".concat(minuteDocs.length, " documents"));
                offPeakHoursConsumption = minuteDocs.reduce(function (sum, doc) {
                  return sum + doc.load;
                }, 0);
                return _context7.abrupt("return", offPeakHoursConsumption);
              case 33:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[2, 24, 27, 30]]);
      }));
      function getOffPeakHourConsumption(_x9, _x10, _x11) {
        return _getOffPeakHourConsumption.apply(this, arguments);
      }
      return getOffPeakHourConsumption;
    }()
  }]);
  return EnedisMonthlyAnalysisDataService;
}();

/***/ })

}]);